
<?php
  header('Content-type: text/html; charset=utf-8', true);

  include_once '../includes/aibridge.class.php';
  include_once '../includes/globals.php';
  include_once '../includes/rosetta.class.php';

  if (isAdminMode() === false)
  {
    $outputArray = array(
      'name'  => 'Error',
      'value' => 'Operation not permitted');
    die(Rosetta::arrayToJSON($outputArray));
  }
  // Call AI
  $stdout = AIBridge::clearSpdErrors();

  // Try to make stdout into a XMLDocument
  $xml = new XMLDocument($stdout);
  if ($xml)
  {
    $document = $xml->document_element();
    if ($document->tagname() == 'error') // If AI returned an error:
    {
      $outputArray = array(
        'name'  => 'AI Error',
        'value' => $document->get_content());
      die(Rosetta::arrayToJSON($outputArray));
    }

    $xpath = xpath_new_context($document);
    $properties = @ xpath_eval($xpath, '/spdClearLogRecord');
    foreach ($properties->nodeset as $property)
    {
      $propertyCardNum = $property->get_attribute('Card');
      $propertyDimmNum = $property->get_attribute('DIMM');
      $propertyIsClearOperation = $property->get_attribute('status');
      if ($propertyIsClearOperation === 1)
      {
        $cleared.= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".translate('MSG_CARD').":".$propertyCardNum.", ".translate('MSG_ME_DIMM').":".$propertyDimmNum."<br/>";
      }
      else
      {
        $notcleared.= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".translate('MSG_CARD').":".$propertyCardNum.", ".translate('MSG_ME_DIMM').":".$propertyDimmNum."<br/>";
      }
    }
    echo "<div style=\"text-align: left;\">";
    if(!empty($cleared)) {
      echo translate('MSG_DIMM_SPD_BYTES_CLEARED')."<br/>".$cleared;
    }
    if(!empty($notcleared)) {
      echo "<br/>".translate('MSG_DIMM_SPD_BYTES_NOT_CLEARED')."<br/>".$notcleared;
    }
    if(empty($property)) {
      echo "<br/>".translate('MSG_ALL_SPD_DIMMS_ARE_GOOD')."<br/>";
    }
    echo "</div>";
  }
  else
  {
    $outputArray = array(
      'name'  => 'XML Error',
      'value' => $stdout);
    die(Rosetta::arrayToJSON($outputArray));
  }
?>

