function SaveDialogPrompt()
{
  inherit(this, new ModalElement(getElement('saveDialogPrompt')));
  this.header = extendElement(getElement('saveDialogPromptHeader'));
  this.currentConfigPrompt = extendElement(getElement('saveDialogPromptCurrentConfig'));
  this.currentConfigLabel = extendElement(getElement('saveDialogPromptCurrentConfigLabel'));
  this.allConfig = extendElement(getElement('saveDialogPromptAllConfig'));
  this.allConfigLabel = extendElement(getElement('saveDialogPromptAllConfigLabel'));
  this.cancelButton = extendElement(getElement('saveDialogPromptCancelButton'));
  this.okButton = extendElement(getElement('saveDialogPromptOkButton'));
    
  this.isVisible = false;
  this.init();
}
  
SaveDialogPrompt.prototype.init = function init()
{
  this.cancelButton.controller = this;
  this.cancelButton.onclick = function ()
  {
    this.controller.hide();
    this.controller.resetRadioButtons();
  }
  
  this.okButton.controller = this;
  this.okButton.onclick = function ()
  {
    this.controller.saveOk();
  }
}

SaveDialogPrompt.prototype.didShow = function didShow()
{
  this.isVisible = true;
}
  
SaveDialogPrompt.prototype.didHide = function didHide()
{
  this.isVisible = false;
}
 	
/********************************************************************
// SaveDialogPrompt.getCategory(): function
// Gets the Categories  caption
********************************************************************/
SaveDialogPrompt.prototype.getCategory = function getCategory()
{
  var element = getElement("currentConfigCategory");
  var index = element.selectedIndex;
  var value = element.getElementsByTagName("option")[index].innerHTML;
  return value;
}
  
/********************************************************************	
// SaveDialogPrompt.getViewLevel(): function
// Gets the viewlevel caption
********************************************************************/
SaveDialogPrompt.prototype.getViewLevel = function getViewLevel()
{
  var element = getElement("currentConfigViewLevel");
  var index = element.selectedIndex;
  var value = element.getElementsByTagName("option")[index].innerHTML;
  return value;
} 

SaveDialogPrompt.prototype.openDialog = function openDialog(title, filename, controller)
{
  this.title = title;
  this.header.innerHTML = title;
  this.controller = controller;
  this.header.innerHTML = title;
  this.currentConfigLabel.innerHTML = translate('MSG_SAVE') + ' ' + translate('MSG_CURRENT_VIEW') + '(' + this.getCategory() + ', ' + this.getViewLevel() + ')';
  this.allConfigLabel.innerHTML = translate('MSG_SAVE') + ' ' + translate('MSG_ENTIRE_SURVEY') + '(' + translate('MSG_ALL') + ', ' + translate("MSG_ADVANCED") + ')';
  this.show();
}
SaveDialogPrompt.prototype.resetRadioButtons = function resetRadioButtons()
{
  this.allConfig.checked = true;
}
	
SaveDialogPrompt.prototype.saveOk = function saveOk()
{
  var uscore = this.getCategory();
  uscore = uscore.replace(' ','_');
  if(CONFIG.IS_ONLINE == true)
  { 
   if(this.currentConfigPrompt.checked == true)
   {
   	var header = (translate('MSG_SAVE') + ' ' + translate('MSG_CURRENT_VIEW'));
    var query =
    {
        attachment : 1,
        filename   : 'Survey' + '_' + Frontend.currentConfig.currentCategory + '_' + Frontend.currentConfig.currentViewLevel,
        category   : Frontend.currentConfig.currentCategory,
        advanced   : (Frontend.currentConfig.currentViewLevel == 'advanced') ? 'yes' : 'no'
	}
    Frontend.clientSave(Frontend.currentConfig.saveCommand, query, header);
    this.hide();
    this.resetRadioButtons();
  }  
  else 
  {
    var header = (translate('MSG_SAVE') + ' ' + translate('MSG_ALL'));
    var query =
    {
      attachment : 1,
      filename   : 'Survey' + '_' + 'all' + '_' + 'advanced',
      category   : 'all',
      advanced   : 'yes' 
    }
    Frontend.clientSave(Frontend.currentConfig.saveCommand, query, header);
    this.hide();
  }
 }
 else 
 {
   var header = (translate('MSG_SAVE') + ' ' + translate('MSG_CONFIGURATION'));
   if(this.currentConfigPrompt.checked == true) 
   {
     Frontend.saveDialog.openDialog(header, 'Survey' + '_'  +  Frontend.currentConfig.currentCategory + '_' +  Frontend.currentConfig.currentViewLevel, this);
   }
   else
   {
     Frontend.saveDialog.openDialog(header, 'Survey' + '_' + 'all' + '_' + 'advanced', this);
   }
   this.hide();
 }
}
	 
SaveDialogPrompt.prototype.endInform = function endInform(doShowSelf)
{
	if (doShowSelf)
  	  this.show();
    Frontend.dialog.hide();
}

